package com.ezet.crowdstream.client.services

import android.app.IntentService
import android.content.Intent
import android.os.Binder
import android.os.IBinder
import android.util.Log
import io.reactivex.Observable
import java.util.concurrent.ExecutorService
import java.util.concurrent.Executors

class CwsNetworkService : IntentService("CwsNetworkService") {

    override fun onHandleIntent(intent: Intent?) {
        throw NotImplementedError()
        TODO("not implemented") //To change body of created functions use File | Settings | File Templates.
    }

    private val binder = LocalBinder()
    private val tcpClient: TcpClient = TcpClient()
    private val executorService: ExecutorService = Executors.newSingleThreadExecutor()

    fun sendMessage(data: String) {
        Log.d(TAG, "sendMessage: $data")
        executorService.execute { tcpClient.sendMessage(data) }
    }

    val data: Observable<String>
        get() = tcpClient.data

    val status: Observable<Int>?
        get() = tcpClient.events.map {
            when (it) {
                TcpClient.CONNECTED -> {
                    CONNECTED
                }
                TcpClient.DISCONNECTED -> {
                    DISCONNECTED
                }
                TcpClient.CONNECTING -> CONNECTING
                else -> it
            }
        }


    override fun onBind(intent: Intent): IBinder = binder

    fun connect(ip: String, port: Int) = tcpClient.connect(ip, port)

    fun disconnect() = tcpClient.disconnect()


    /**
     * Class used for the client Binder.  Because we know this service always
     * runs in the same process as its clients, we don't need to deal with IPC.
     */
    inner class LocalBinder : Binder() {
        val service: CwsNetworkService
            get() = this@CwsNetworkService
    }

    companion object {
        val CONNECTING: Int = 0
        val CONNECTED: Int = 1
        val DISCONNECTED: Int = 2
        val EXTRA_IP = "EXTRA_IP"
        val EXTRA_PORT = "EXTRA_PORT"
        private val TAG = "CwsNetworkService"
    }


}
