package com.ezet.crowdstream.client.services


import android.app.Application
import android.content.SharedPreferences
import android.content.res.Resources
import android.preference.PreferenceManager
import android.support.annotation.StringRes

class PreferenceService(application: Application) {

    private val defaultSharedPreferences: SharedPreferences = PreferenceManager.getDefaultSharedPreferences(application)
    private val resources: Resources = application.resources

    fun getBoolean(@StringRes resId: Int): Boolean {
        return defaultSharedPreferences.getBoolean(resources.getString(resId), false)
    }

    fun getString(@StringRes resId: Int): String {
        return defaultSharedPreferences.getString(resources.getString(resId), "")
    }

    fun putString(@StringRes resId: Int, value: String) {
        defaultSharedPreferences.edit().putString(resources.getString(resId), value).apply()
    }

    operator fun contains(@StringRes resId: Int): Boolean {
        return defaultSharedPreferences.contains(resources.getString(resId))
    }

    fun getInt(@StringRes resId: Int): Int {
        return defaultSharedPreferences.getInt(resources.getString(resId), 0)
    }

    fun putInt(@StringRes resId: Int, value: Int) {
        defaultSharedPreferences.edit().putInt(resources.getString(resId), value).apply()
    }

    fun putLong(@StringRes resId: Int, value: Long) {
        putLong(resources.getString(resId), value)
    }

    fun putLong(key: String, value: Long) {
        defaultSharedPreferences.edit().putLong(key, value).apply()
    }

    fun getLong(@StringRes resId: Int): Long {
        return getLong(resources.getString(resId))
    }

    fun getLong(key: String): Long {
        return defaultSharedPreferences.getLong(key, 0)
    }
}