package com.ezet.crowdstream.client.streamactivity

import android.content.Context
import android.graphics.Canvas
import android.util.AttributeSet
import android.view.SurfaceHolder
import android.view.SurfaceView

class StreamSurfaceView : SurfaceView, SurfaceHolder.Callback {

    private var canDraw: Boolean = false

    constructor(context: Context) : super(context) {
        init()
    }

    constructor(context: Context, attrs: AttributeSet) : super(context, attrs) {
        init()
    }

    constructor(context: Context, attrs: AttributeSet, defStyleAttr: Int) : super(context, attrs, defStyleAttr) {
        init()
    }

    private fun init() {
        holder.addCallback(this)
    }

    fun drawColor(r: Int, g: Int, b: Int) {
        if (!canDraw) return
        val canvas: Canvas = if (android.os.Build.VERSION.SDK_INT >= android.os.Build.VERSION_CODES.O) {
            holder.lockHardwareCanvas()
        } else {
            holder.lockCanvas()
        }
        canvas.drawRGB(r, g, b)
        holder.unlockCanvasAndPost(canvas)
    }

    override fun surfaceCreated(surfaceHolder: SurfaceHolder) {
        canDraw = true
        drawColor(0, 0, 0)
    }

    override fun surfaceChanged(surfaceHolder: SurfaceHolder, i: Int, i1: Int, i2: Int) {
        drawColor(0, 0, 0)
    }

    override fun surfaceDestroyed(surfaceHolder: SurfaceHolder) {
        canDraw = false
    }
}