import fire

from crowdstream.cli_client import CliClient


class Cli:
    _ip = '127.0.0.1'
    _port = 8000
    _password = 123123

    def __init__(self):
        self._client = None

    def _send(self, data):
        self._client = CliClient.send(self._ip, self._port, self._password, data)


class SetCli:
    """
    Set configuration
    """

    def port(self, port):
        pass

    def ip(self, ip):
        pass

    def password(self, password):
        pass


class CrowdstreamCli(Cli):

    def __init__(self):
        super().__init__()
        self.set = SetCli

    def stopstream(self):
        """
        Stop streaming
        """
        self._send(f"stream stop")

    def stream(self, src):
        """
        Start streaming the provided source
        :param src: Streaming source, either an camera ID or a filename
        """
        self._send(f"stream {src}")

    def set(self):
        pass

    def init(self, rounds):
        """
        Start initialization
        :param rounds: Maximum number of initialization rounds
        """
        self._send(f"init {rounds}")

    def status(self):
        """
        Server connection status
        """
        self._send('status')


def main():
    fire.Fire(CrowdstreamCli)


if __name__ == "__main__":
    fire.Fire(CrowdstreamCli)
