import logging
import sys

import fire

from crowdstream.admin_client import AdminClient
from crowdstream.server import CrowdstreamServer

logging.basicConfig(stream=sys.stdout, level=logging.INFO)


def start(port: int = 8000, password: str = '123123'):
    server = CrowdstreamServer()
    server.start(port, password)


def connect(password: str, ip: str = "localhost", port: int = 8000):
    client = AdminClient()
    client.connect(ip, port, password)


def main():
    fire.Fire({
        'start': start,
    })


if __name__ == "__main__":
    main()
