SEQUENCE_LENGTH = 32  # Number of symbols in init sequence
SYMBOL_FREQUENCY = 5  # Number of symbols to display per second during init sequence
CAMERA_DIMENSIONS = (1080, 720)  # Dimensions of camera used to record init sequence
SAMPLE_RECTANGLE_SIZE = 1  # Size of source sample when streaming image/video
SEQUENCE_PREFIX = "101"  # A prefix for all sequences
MAP_VISIBLE_FIRST = False  # If true, maps all currently visible devices before mapping hidden devices
MAX_SYMBOL_STREAK = 3  # Maximum number of subsequent equal symbols in a row
DETECTION_THRESHOLD = 200  # Global threshold for detection
EXTEND_CAPTURE_SECONDS = 1
DEFAULT_MAX_INIT_ROUNDS = 3
DEFAULT_WARMUP_FRAMES = 5  # warmup frames for the camera before starting the recording

# TEST SETTINGS
TEST_DEFAULT_VIDEO_FPS = 30
TEST_DEFAULT_DEVICE_SHAPE = (20, 20)  # Device configuration shape for testing
TEST_DEFAULT_DEVICE_SIZE = int(
    min(CAMERA_DIMENSIONS[0] / TEST_DEFAULT_DEVICE_SHAPE[0] / 2,
        CAMERA_DIMENSIONS[1] / TEST_DEFAULT_DEVICE_SHAPE[0] / 2))

# not used
SYMBOLS_UNTIL_PERMANENT_LOSS = 10  # number of symbol hidden before we permanently discard a device
FRAMES_UNTIL_PERMANENT_LOSS = TEST_DEFAULT_VIDEO_FPS / SYMBOL_FREQUENCY * SYMBOLS_UNTIL_PERMANENT_LOSS  # number of frames hidden before we permanently discard a device
