import logging
import sys

from crowdstream import CrowdstreamServer
from crowdstream.services.devices import DeviceService
from tests.mocks.CameraServiceMock import CameraServiceMock
from tests.mocks.NetworkServiceMock import NetworkServiceMock

# logging.basicConfig(stream=sys.stdout, level=logging.DEBUG)


def test__mock_sequence():
    camera_service = CameraServiceMock(None, (50, 50))
    server = CrowdstreamServer()
    server._device_service.camera_service = camera_service
    camera_service.plug_camera_mock(server._device_service)
    server.start()


def test__mock_sequence_and_clients():
    server = CrowdstreamServer()
    camera_service = CameraServiceMock(None, (10, 10))
    network_service = NetworkServiceMock(camera_service.device_shape[0] * camera_service.device_shape[1],
                                         server.data_received)
    device_service = DeviceService(network_service, camera_service)
    device_service.DEBUG = True
    device_service.DEBUG_FRAME_DELAY = 10
    network_service.mock(device_service)
    camera_service.plug_camera_mock(device_service)
    server._device_service = device_service
    server._network_service = network_service
    server.start()


def test():
    server = CrowdstreamServer()
    server._device_service.DEBUG = True
    from crowdstream.utils import tracking
    tracking.DEBUG = True
    server.start()


if __name__ == "__main__":
    test__mock_sequence_and_clients()
    # test__mock_sequence()
    # test()
