from typing import Iterable, Tuple

import cv2
import numpy as np

FORMAT = "mp4v"


def write_video(fps: int, frames: Iterable, size: Tuple[int, int], filename: str):
    writer = cv2.VideoWriter(filename=f"{filename}.mp4", apiPreference=cv2.CAP_FFMPEG,
                             fourcc=cv2.VideoWriter_fourcc(*FORMAT), fps=fps,
                             frameSize=size, isColor=True)
    for frame in frames:
        writer.write(frame)
    writer.release()


def create_empty_frame(width, height):
    return np.zeros((height, width, 3), dtype='uint8')
